#include <stdio.h>
#include <stdlib.h>

// globally allocated
int x[10];

int
main(int argc, char *argv[])
{
    // stack allocated
    int a[10]; // 40 bytes contiguous (all together)

    // heap allocated
    // int *a = malloc(10 * sizeof(int)); // next time: malloc
    // free(a);

    // access
    a[0] = 99; // x86 code to do this: ??
    a[1] = 98;

    // another array: what size
    //char b[10];

    // size
    printf("sizeof(a): %d\n", sizeof(a));

    // pointer equivalence
    printf("address of a[0]: %p\n", &a[0]);
    printf("address: %p\n", a);

    // ptr arithmetic too!
    printf("address of a[1]: %p\n", (a+1));
    printf("value: %d\n", *(a+1)); // really a[1]

    // even weirder
    printf("value: %d\n", *(0+a));
    printf("value: %d\n", 0[a]);   // *(0+a)

    return 0;
}


